/////////////////////////////////////////////////////////////////////////////// //
//    (C) Copyright 1995 - 1998 OSR Open Systems Resources, Inc.
//    All Rights Reserved
//
//    This sofware is supplied for instructional purposes only.
//
//    OSR Open Systems Resources, Inc. (OSR) expressly disclaims any warranty
//    for this software.  THIS SOFTWARE IS PROVIDED  "AS IS" WITHOUT WARRANTY
//    OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING, WITHOUT LIMITATION,
//    THE IMPLIED WARRANTIES OF MECHANTABILITY OR FITNESS FOR A PARTICULAR
//    PURPOSE.  THE ENTIRE RISK ARISING FROM THE USE OF THIS SOFTWARE REMAINS
//    WITH YOU.  OSR's entire liability and your exclusive remedy shall not
//    exceed the price paid for this material.  In no event shall OSR or its
//    suppliers be liable for any damages whatsoever (including, without
//    limitation, damages for loss of business profit, business interruption,
//    loss of business information, or any other pecuniary loss) arising out
//    of the use or inability to use this software, even if OSR has been
//    advised of the possibility of such damages.  Because some states/
//    jurisdictions do not allow the exclusion or limitation of liability for
//    consequential or incidental damages, the above limitation may not apply
//    to you.
//
//    OSR Open Systems Resources, Inc.
//    105 Route 101A Suite 19
//    Amherst, NH 03031  (603) 595-6500 FAX: (603) 595-6503
//    email bugs to: bugs@osr.com
//
//
//    MODULE:
//
//        nothing.h
//
//    ABSTRACT:
//
//		This is the general include file for the OSRMEMDRV sample driver.
//
//    AUTHOR(S):
//
//        OSR Open Systems Resources, Inc.
// 
//    REVISION:   
//
//
///////////////////////////////////////////////////////////////////////////////
#ifndef __OSRMEMDRV_H__
#define __OSRMEMDRV_H__ (1) // suppress duplicate loading of this file

#include "OSRMEMDRV_IOCTL.h"

typedef struct _MEM_USER_ENTRY
{
    LIST_ENTRY      ListEntry;
    PFILE_OBJECT    FileObject;         // File Object of queuer
    PVOID           UserVaToReturn;     // Mapped VA for the process
    PMDL            PMdl;               // MDL used to map memory
    PIRP            Irp;                // If a hanging IRP was used.

} MEM_USER_ENTRY, *PMEM_USER_ENTRY;

//
// Device Extension
//
// This is the per-device component of the device object.
//
typedef struct _OSRMEMDRV_DEV_EXT
{
	//
	// Device information
	//
	PDEVICE_OBJECT		DeviceObject;

	//
	// List of users doing a create to the driver.  Entries
    // in this list will contain the memory mapped for each
    // open file object.
	//
    FAST_MUTEX      MemUserListMutex;
    LIST_ENTRY      MemUserList;

    //
    // List of users doing a IOCTL_OSR_SETSHAREMEM call to the
    // driver.   We only allow one requests per file object.
    // An entry in this list contains the IRP we are holding on
    // to which holds the memory address that we are sharing
    // with the application.
    FAST_MUTEX      IrpQueueMutex;
    LIST_ENTRY      IrpQueue;

} OSRMEMDRV_DEVICE_EXT, *POSRMEMDRV_DEVICE_EXT;


#endif /* __OSRMEMDRV_H__ */
